/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * Represents a notification sent to Cloud Pub/Sub subscribers for conversation lifecycle events.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2ConversationEvent extends com.google.api.client.json.GenericJson {

  /**
   * The unique identifier of the conversation this notification refers to. Format:
   * `projects//conversations/`.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String conversation;

  /**
   * More detailed information about an error. Only set for type UNRECOVERABLE_ERROR_IN_PHONE_CALL.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private GoogleRpcStatus errorStatus;

  /**
   * Payload of NEW_MESSAGE event.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private GoogleCloudDialogflowV2Message newMessagePayload;

  /**
   * The type of the event that this notification refers to.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String type;

  /**
   * The unique identifier of the conversation this notification refers to. Format:
   * `projects//conversations/`.
   * @return value or {@code null} for none
   */
  public java.lang.String getConversation() {
    return conversation;
  }

  /**
   * The unique identifier of the conversation this notification refers to. Format:
   * `projects//conversations/`.
   * @param conversation conversation or {@code null} for none
   */
  public GoogleCloudDialogflowV2ConversationEvent setConversation(java.lang.String conversation) {
    this.conversation = conversation;
    return this;
  }

  /**
   * More detailed information about an error. Only set for type UNRECOVERABLE_ERROR_IN_PHONE_CALL.
   * @return value or {@code null} for none
   */
  public GoogleRpcStatus getErrorStatus() {
    return errorStatus;
  }

  /**
   * More detailed information about an error. Only set for type UNRECOVERABLE_ERROR_IN_PHONE_CALL.
   * @param errorStatus errorStatus or {@code null} for none
   */
  public GoogleCloudDialogflowV2ConversationEvent setErrorStatus(GoogleRpcStatus errorStatus) {
    this.errorStatus = errorStatus;
    return this;
  }

  /**
   * Payload of NEW_MESSAGE event.
   * @return value or {@code null} for none
   */
  public GoogleCloudDialogflowV2Message getNewMessagePayload() {
    return newMessagePayload;
  }

  /**
   * Payload of NEW_MESSAGE event.
   * @param newMessagePayload newMessagePayload or {@code null} for none
   */
  public GoogleCloudDialogflowV2ConversationEvent setNewMessagePayload(GoogleCloudDialogflowV2Message newMessagePayload) {
    this.newMessagePayload = newMessagePayload;
    return this;
  }

  /**
   * The type of the event that this notification refers to.
   * @return value or {@code null} for none
   */
  public java.lang.String getType() {
    return type;
  }

  /**
   * The type of the event that this notification refers to.
   * @param type type or {@code null} for none
   */
  public GoogleCloudDialogflowV2ConversationEvent setType(java.lang.String type) {
    this.type = type;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2ConversationEvent set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2ConversationEvent) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2ConversationEvent clone() {
    return (GoogleCloudDialogflowV2ConversationEvent) super.clone();
  }

}
