/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * The message returned from the DetectIntent method.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2DetectIntentResponse extends com.google.api.client.json.GenericJson {

  /**
   * The audio data bytes encoded as specified in the request. Note: The output audio is generated
   * based on the values of default platform text responses found in the
   * `query_result.fulfillment_messages` field. If multiple default text responses exist, they will
   * be concatenated when generating audio. If no default platform text responses exist, the
   * generated audio content will be empty.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String outputAudio;

  /**
   * The config used by the speech synthesizer to generate the output audio.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private GoogleCloudDialogflowV2OutputAudioConfig outputAudioConfig;

  /**
   * The selected results of the conversational query or event processing. See
   * `alternative_query_results` for additional potential results.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private GoogleCloudDialogflowV2QueryResult queryResult;

  /**
   * The unique identifier of the response. It can be used to locate a response in the training
   * example set or for reporting issues.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String responseId;

  /**
   * Specifies the status of the webhook request.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private GoogleRpcStatus webhookStatus;

  /**
   * The audio data bytes encoded as specified in the request. Note: The output audio is generated
   * based on the values of default platform text responses found in the
   * `query_result.fulfillment_messages` field. If multiple default text responses exist, they will
   * be concatenated when generating audio. If no default platform text responses exist, the
   * generated audio content will be empty.
   * @see #decodeOutputAudio()
   * @return value or {@code null} for none
   */
  public java.lang.String getOutputAudio() {
    return outputAudio;
  }

  /**
   * The audio data bytes encoded as specified in the request. Note: The output audio is generated
   * based on the values of default platform text responses found in the
   * `query_result.fulfillment_messages` field. If multiple default text responses exist, they will
   * be concatenated when generating audio. If no default platform text responses exist, the
   * generated audio content will be empty.
   * @see #getOutputAudio()
   * @return Base64 decoded value or {@code null} for none
   *
   * @since 1.14
   */
  public byte[] decodeOutputAudio() {
    return com.google.api.client.util.Base64.decodeBase64(outputAudio);
  }

  /**
   * The audio data bytes encoded as specified in the request. Note: The output audio is generated
   * based on the values of default platform text responses found in the
   * `query_result.fulfillment_messages` field. If multiple default text responses exist, they will
   * be concatenated when generating audio. If no default platform text responses exist, the
   * generated audio content will be empty.
   * @see #encodeOutputAudio()
   * @param outputAudio outputAudio or {@code null} for none
   */
  public GoogleCloudDialogflowV2DetectIntentResponse setOutputAudio(java.lang.String outputAudio) {
    this.outputAudio = outputAudio;
    return this;
  }

  /**
   * The audio data bytes encoded as specified in the request. Note: The output audio is generated
   * based on the values of default platform text responses found in the
   * `query_result.fulfillment_messages` field. If multiple default text responses exist, they will
   * be concatenated when generating audio. If no default platform text responses exist, the
   * generated audio content will be empty.
   * @see #setOutputAudio()
   *
   * <p>
   * The value is encoded Base64 or {@code null} for none.
   * </p>
   *
   * @since 1.14
   */
  public GoogleCloudDialogflowV2DetectIntentResponse encodeOutputAudio(byte[] outputAudio) {
    this.outputAudio = com.google.api.client.util.Base64.encodeBase64URLSafeString(outputAudio);
    return this;
  }

  /**
   * The config used by the speech synthesizer to generate the output audio.
   * @return value or {@code null} for none
   */
  public GoogleCloudDialogflowV2OutputAudioConfig getOutputAudioConfig() {
    return outputAudioConfig;
  }

  /**
   * The config used by the speech synthesizer to generate the output audio.
   * @param outputAudioConfig outputAudioConfig or {@code null} for none
   */
  public GoogleCloudDialogflowV2DetectIntentResponse setOutputAudioConfig(GoogleCloudDialogflowV2OutputAudioConfig outputAudioConfig) {
    this.outputAudioConfig = outputAudioConfig;
    return this;
  }

  /**
   * The selected results of the conversational query or event processing. See
   * `alternative_query_results` for additional potential results.
   * @return value or {@code null} for none
   */
  public GoogleCloudDialogflowV2QueryResult getQueryResult() {
    return queryResult;
  }

  /**
   * The selected results of the conversational query or event processing. See
   * `alternative_query_results` for additional potential results.
   * @param queryResult queryResult or {@code null} for none
   */
  public GoogleCloudDialogflowV2DetectIntentResponse setQueryResult(GoogleCloudDialogflowV2QueryResult queryResult) {
    this.queryResult = queryResult;
    return this;
  }

  /**
   * The unique identifier of the response. It can be used to locate a response in the training
   * example set or for reporting issues.
   * @return value or {@code null} for none
   */
  public java.lang.String getResponseId() {
    return responseId;
  }

  /**
   * The unique identifier of the response. It can be used to locate a response in the training
   * example set or for reporting issues.
   * @param responseId responseId or {@code null} for none
   */
  public GoogleCloudDialogflowV2DetectIntentResponse setResponseId(java.lang.String responseId) {
    this.responseId = responseId;
    return this;
  }

  /**
   * Specifies the status of the webhook request.
   * @return value or {@code null} for none
   */
  public GoogleRpcStatus getWebhookStatus() {
    return webhookStatus;
  }

  /**
   * Specifies the status of the webhook request.
   * @param webhookStatus webhookStatus or {@code null} for none
   */
  public GoogleCloudDialogflowV2DetectIntentResponse setWebhookStatus(GoogleRpcStatus webhookStatus) {
    this.webhookStatus = webhookStatus;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2DetectIntentResponse set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2DetectIntentResponse) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2DetectIntentResponse clone() {
    return (GoogleCloudDialogflowV2DetectIntentResponse) super.clone();
  }

}
