/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * Represents an entity type. Entity types serve as a tool for extracting parameter values from
 * natural language queries.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2EntityType extends com.google.api.client.json.GenericJson {

  /**
   * Optional. Indicates whether the entity type can be automatically expanded.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String autoExpansionMode;

  /**
   * Required. The name of the entity type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String displayName;

  /**
   * Optional. Enables fuzzy entity extraction during classification.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean enableFuzzyExtraction;

  /**
   * Optional. The collection of entity entries associated with the entity type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<GoogleCloudDialogflowV2EntityTypeEntity> entities;

  static {
    // hack to force ProGuard to consider GoogleCloudDialogflowV2EntityTypeEntity used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(GoogleCloudDialogflowV2EntityTypeEntity.class);
  }

  /**
   * Required. Indicates the kind of entity type.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * The unique identifier of the entity type. Required for EntityTypes.UpdateEntityType and
   * EntityTypes.BatchUpdateEntityTypes methods. Format: `projects//agent/entityTypes/`.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * Optional. Indicates whether the entity type can be automatically expanded.
   * @return value or {@code null} for none
   */
  public java.lang.String getAutoExpansionMode() {
    return autoExpansionMode;
  }

  /**
   * Optional. Indicates whether the entity type can be automatically expanded.
   * @param autoExpansionMode autoExpansionMode or {@code null} for none
   */
  public GoogleCloudDialogflowV2EntityType setAutoExpansionMode(java.lang.String autoExpansionMode) {
    this.autoExpansionMode = autoExpansionMode;
    return this;
  }

  /**
   * Required. The name of the entity type.
   * @return value or {@code null} for none
   */
  public java.lang.String getDisplayName() {
    return displayName;
  }

  /**
   * Required. The name of the entity type.
   * @param displayName displayName or {@code null} for none
   */
  public GoogleCloudDialogflowV2EntityType setDisplayName(java.lang.String displayName) {
    this.displayName = displayName;
    return this;
  }

  /**
   * Optional. Enables fuzzy entity extraction during classification.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getEnableFuzzyExtraction() {
    return enableFuzzyExtraction;
  }

  /**
   * Optional. Enables fuzzy entity extraction during classification.
   * @param enableFuzzyExtraction enableFuzzyExtraction or {@code null} for none
   */
  public GoogleCloudDialogflowV2EntityType setEnableFuzzyExtraction(java.lang.Boolean enableFuzzyExtraction) {
    this.enableFuzzyExtraction = enableFuzzyExtraction;
    return this;
  }

  /**
   * Optional. The collection of entity entries associated with the entity type.
   * @return value or {@code null} for none
   */
  public java.util.List<GoogleCloudDialogflowV2EntityTypeEntity> getEntities() {
    return entities;
  }

  /**
   * Optional. The collection of entity entries associated with the entity type.
   * @param entities entities or {@code null} for none
   */
  public GoogleCloudDialogflowV2EntityType setEntities(java.util.List<GoogleCloudDialogflowV2EntityTypeEntity> entities) {
    this.entities = entities;
    return this;
  }

  /**
   * Required. Indicates the kind of entity type.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * Required. Indicates the kind of entity type.
   * @param kind kind or {@code null} for none
   */
  public GoogleCloudDialogflowV2EntityType setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * The unique identifier of the entity type. Required for EntityTypes.UpdateEntityType and
   * EntityTypes.BatchUpdateEntityTypes methods. Format: `projects//agent/entityTypes/`.
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * The unique identifier of the entity type. Required for EntityTypes.UpdateEntityType and
   * EntityTypes.BatchUpdateEntityTypes methods. Format: `projects//agent/entityTypes/`.
   * @param name name or {@code null} for none
   */
  public GoogleCloudDialogflowV2EntityType setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2EntityType set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2EntityType) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2EntityType clone() {
    return (GoogleCloudDialogflowV2EntityType) super.clone();
  }

}
