/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * Represents an agent environment.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2Environment extends com.google.api.client.json.GenericJson {

  /**
   * Optional. The agent version loaded into this environment. Format: `projects//agent/versions/`.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String agentVersion;

  /**
   * Optional. The developer-provided description for this environment. The maximum length is 500
   * characters. If exceeded, the request is rejected.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String description;

  /**
   * Output only. The unique identifier of this agent environment. Format:
   * `projects//agent/environments/`. For Environment ID, "-" is reserved for 'draft' environment.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * Output only. The state of this environment. This field is read-only, i.e., it cannot be set by
   * create and update methods.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String state;

  /**
   * Output only. The last update time of this environment. This field is read-only, i.e., it cannot
   * be set by create and update methods.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String updateTime;

  /**
   * Optional. The agent version loaded into this environment. Format: `projects//agent/versions/`.
   * @return value or {@code null} for none
   */
  public java.lang.String getAgentVersion() {
    return agentVersion;
  }

  /**
   * Optional. The agent version loaded into this environment. Format: `projects//agent/versions/`.
   * @param agentVersion agentVersion or {@code null} for none
   */
  public GoogleCloudDialogflowV2Environment setAgentVersion(java.lang.String agentVersion) {
    this.agentVersion = agentVersion;
    return this;
  }

  /**
   * Optional. The developer-provided description for this environment. The maximum length is 500
   * characters. If exceeded, the request is rejected.
   * @return value or {@code null} for none
   */
  public java.lang.String getDescription() {
    return description;
  }

  /**
   * Optional. The developer-provided description for this environment. The maximum length is 500
   * characters. If exceeded, the request is rejected.
   * @param description description or {@code null} for none
   */
  public GoogleCloudDialogflowV2Environment setDescription(java.lang.String description) {
    this.description = description;
    return this;
  }

  /**
   * Output only. The unique identifier of this agent environment. Format:
   * `projects//agent/environments/`. For Environment ID, "-" is reserved for 'draft' environment.
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * Output only. The unique identifier of this agent environment. Format:
   * `projects//agent/environments/`. For Environment ID, "-" is reserved for 'draft' environment.
   * @param name name or {@code null} for none
   */
  public GoogleCloudDialogflowV2Environment setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  /**
   * Output only. The state of this environment. This field is read-only, i.e., it cannot be set by
   * create and update methods.
   * @return value or {@code null} for none
   */
  public java.lang.String getState() {
    return state;
  }

  /**
   * Output only. The state of this environment. This field is read-only, i.e., it cannot be set by
   * create and update methods.
   * @param state state or {@code null} for none
   */
  public GoogleCloudDialogflowV2Environment setState(java.lang.String state) {
    this.state = state;
    return this;
  }

  /**
   * Output only. The last update time of this environment. This field is read-only, i.e., it cannot
   * be set by create and update methods.
   * @return value or {@code null} for none
   */
  public String getUpdateTime() {
    return updateTime;
  }

  /**
   * Output only. The last update time of this environment. This field is read-only, i.e., it cannot
   * be set by create and update methods.
   * @param updateTime updateTime or {@code null} for none
   */
  public GoogleCloudDialogflowV2Environment setUpdateTime(String updateTime) {
    this.updateTime = updateTime;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2Environment set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2Environment) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2Environment clone() {
    return (GoogleCloudDialogflowV2Environment) super.clone();
  }

}
