/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * Represents a fulfillment.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2Fulfillment extends com.google.api.client.json.GenericJson {

  /**
   * Optional. The human-readable name of the fulfillment, unique within the agent.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String displayName;

  /**
   * Optional. Whether fulfillment is enabled.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean enabled;

  /**
   * Optional. The field defines whether the fulfillment is enabled for certain features.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<GoogleCloudDialogflowV2FulfillmentFeature> features;

  static {
    // hack to force ProGuard to consider GoogleCloudDialogflowV2FulfillmentFeature used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(GoogleCloudDialogflowV2FulfillmentFeature.class);
  }

  /**
   * Configuration for a generic web service.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private GoogleCloudDialogflowV2FulfillmentGenericWebService genericWebService;

  /**
   * Required. The unique identifier of the fulfillment. Format: `projects//agent/fulfillment`.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * Optional. The human-readable name of the fulfillment, unique within the agent.
   * @return value or {@code null} for none
   */
  public java.lang.String getDisplayName() {
    return displayName;
  }

  /**
   * Optional. The human-readable name of the fulfillment, unique within the agent.
   * @param displayName displayName or {@code null} for none
   */
  public GoogleCloudDialogflowV2Fulfillment setDisplayName(java.lang.String displayName) {
    this.displayName = displayName;
    return this;
  }

  /**
   * Optional. Whether fulfillment is enabled.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getEnabled() {
    return enabled;
  }

  /**
   * Optional. Whether fulfillment is enabled.
   * @param enabled enabled or {@code null} for none
   */
  public GoogleCloudDialogflowV2Fulfillment setEnabled(java.lang.Boolean enabled) {
    this.enabled = enabled;
    return this;
  }

  /**
   * Optional. The field defines whether the fulfillment is enabled for certain features.
   * @return value or {@code null} for none
   */
  public java.util.List<GoogleCloudDialogflowV2FulfillmentFeature> getFeatures() {
    return features;
  }

  /**
   * Optional. The field defines whether the fulfillment is enabled for certain features.
   * @param features features or {@code null} for none
   */
  public GoogleCloudDialogflowV2Fulfillment setFeatures(java.util.List<GoogleCloudDialogflowV2FulfillmentFeature> features) {
    this.features = features;
    return this;
  }

  /**
   * Configuration for a generic web service.
   * @return value or {@code null} for none
   */
  public GoogleCloudDialogflowV2FulfillmentGenericWebService getGenericWebService() {
    return genericWebService;
  }

  /**
   * Configuration for a generic web service.
   * @param genericWebService genericWebService or {@code null} for none
   */
  public GoogleCloudDialogflowV2Fulfillment setGenericWebService(GoogleCloudDialogflowV2FulfillmentGenericWebService genericWebService) {
    this.genericWebService = genericWebService;
    return this;
  }

  /**
   * Required. The unique identifier of the fulfillment. Format: `projects//agent/fulfillment`.
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * Required. The unique identifier of the fulfillment. Format: `projects//agent/fulfillment`.
   * @param name name or {@code null} for none
   */
  public GoogleCloudDialogflowV2Fulfillment setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2Fulfillment set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2Fulfillment) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2Fulfillment clone() {
    return (GoogleCloudDialogflowV2Fulfillment) super.clone();
  }

}
