/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * Represents configuration for a generic web service. Dialogflow supports two mechanisms for
 * authentications: - Basic authentication with username and password. - Authentication with
 * additional authentication headers. More information could be found at:
 * https://cloud.google.com/dialogflow/docs/fulfillment-configure.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2FulfillmentGenericWebService extends com.google.api.client.json.GenericJson {

  /**
   * Optional. Indicates if generic web service is created through Cloud Functions integration.
   * Defaults to false.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean isCloudFunction;

  /**
   * Optional. The password for HTTP Basic authentication.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String password;

  /**
   * Optional. The HTTP request headers to send together with fulfillment requests.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.Map<String, java.lang.String> requestHeaders;

  /**
   * Required. The fulfillment URI for receiving POST requests.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String uri;

  /**
   * Optional. The user name for HTTP Basic authentication.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String username;

  /**
   * Optional. Indicates if generic web service is created through Cloud Functions integration.
   * Defaults to false.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getIsCloudFunction() {
    return isCloudFunction;
  }

  /**
   * Optional. Indicates if generic web service is created through Cloud Functions integration.
   * Defaults to false.
   * @param isCloudFunction isCloudFunction or {@code null} for none
   */
  public GoogleCloudDialogflowV2FulfillmentGenericWebService setIsCloudFunction(java.lang.Boolean isCloudFunction) {
    this.isCloudFunction = isCloudFunction;
    return this;
  }

  /**
   * Optional. The password for HTTP Basic authentication.
   * @return value or {@code null} for none
   */
  public java.lang.String getPassword() {
    return password;
  }

  /**
   * Optional. The password for HTTP Basic authentication.
   * @param password password or {@code null} for none
   */
  public GoogleCloudDialogflowV2FulfillmentGenericWebService setPassword(java.lang.String password) {
    this.password = password;
    return this;
  }

  /**
   * Optional. The HTTP request headers to send together with fulfillment requests.
   * @return value or {@code null} for none
   */
  public java.util.Map<String, java.lang.String> getRequestHeaders() {
    return requestHeaders;
  }

  /**
   * Optional. The HTTP request headers to send together with fulfillment requests.
   * @param requestHeaders requestHeaders or {@code null} for none
   */
  public GoogleCloudDialogflowV2FulfillmentGenericWebService setRequestHeaders(java.util.Map<String, java.lang.String> requestHeaders) {
    this.requestHeaders = requestHeaders;
    return this;
  }

  /**
   * Required. The fulfillment URI for receiving POST requests.
   * @return value or {@code null} for none
   */
  public java.lang.String getUri() {
    return uri;
  }

  /**
   * Required. The fulfillment URI for receiving POST requests.
   * @param uri uri or {@code null} for none
   */
  public GoogleCloudDialogflowV2FulfillmentGenericWebService setUri(java.lang.String uri) {
    this.uri = uri;
    return this;
  }

  /**
   * Optional. The user name for HTTP Basic authentication.
   * @return value or {@code null} for none
   */
  public java.lang.String getUsername() {
    return username;
  }

  /**
   * Optional. The user name for HTTP Basic authentication.
   * @param username username or {@code null} for none
   */
  public GoogleCloudDialogflowV2FulfillmentGenericWebService setUsername(java.lang.String username) {
    this.username = username;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2FulfillmentGenericWebService set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2FulfillmentGenericWebService) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2FulfillmentGenericWebService clone() {
    return (GoogleCloudDialogflowV2FulfillmentGenericWebService) super.clone();
  }

}
