/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * The basic card message. Useful for displaying information.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2IntentMessageBasicCard extends com.google.api.client.json.GenericJson {

  /**
   * Optional. The collection of card buttons.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<GoogleCloudDialogflowV2IntentMessageBasicCardButton> buttons;

  static {
    // hack to force ProGuard to consider GoogleCloudDialogflowV2IntentMessageBasicCardButton used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(GoogleCloudDialogflowV2IntentMessageBasicCardButton.class);
  }

  /**
   * Required, unless image is present. The body text of the card.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String formattedText;

  /**
   * Optional. The image for the card.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private GoogleCloudDialogflowV2IntentMessageImage image;

  /**
   * Optional. The subtitle of the card.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String subtitle;

  /**
   * Optional. The title of the card.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String title;

  /**
   * Optional. The collection of card buttons.
   * @return value or {@code null} for none
   */
  public java.util.List<GoogleCloudDialogflowV2IntentMessageBasicCardButton> getButtons() {
    return buttons;
  }

  /**
   * Optional. The collection of card buttons.
   * @param buttons buttons or {@code null} for none
   */
  public GoogleCloudDialogflowV2IntentMessageBasicCard setButtons(java.util.List<GoogleCloudDialogflowV2IntentMessageBasicCardButton> buttons) {
    this.buttons = buttons;
    return this;
  }

  /**
   * Required, unless image is present. The body text of the card.
   * @return value or {@code null} for none
   */
  public java.lang.String getFormattedText() {
    return formattedText;
  }

  /**
   * Required, unless image is present. The body text of the card.
   * @param formattedText formattedText or {@code null} for none
   */
  public GoogleCloudDialogflowV2IntentMessageBasicCard setFormattedText(java.lang.String formattedText) {
    this.formattedText = formattedText;
    return this;
  }

  /**
   * Optional. The image for the card.
   * @return value or {@code null} for none
   */
  public GoogleCloudDialogflowV2IntentMessageImage getImage() {
    return image;
  }

  /**
   * Optional. The image for the card.
   * @param image image or {@code null} for none
   */
  public GoogleCloudDialogflowV2IntentMessageBasicCard setImage(GoogleCloudDialogflowV2IntentMessageImage image) {
    this.image = image;
    return this;
  }

  /**
   * Optional. The subtitle of the card.
   * @return value or {@code null} for none
   */
  public java.lang.String getSubtitle() {
    return subtitle;
  }

  /**
   * Optional. The subtitle of the card.
   * @param subtitle subtitle or {@code null} for none
   */
  public GoogleCloudDialogflowV2IntentMessageBasicCard setSubtitle(java.lang.String subtitle) {
    this.subtitle = subtitle;
    return this;
  }

  /**
   * Optional. The title of the card.
   * @return value or {@code null} for none
   */
  public java.lang.String getTitle() {
    return title;
  }

  /**
   * Optional. The title of the card.
   * @param title title or {@code null} for none
   */
  public GoogleCloudDialogflowV2IntentMessageBasicCard setTitle(java.lang.String title) {
    this.title = title;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2IntentMessageBasicCard set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2IntentMessageBasicCard) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2IntentMessageBasicCard clone() {
    return (GoogleCloudDialogflowV2IntentMessageBasicCard) super.clone();
  }

}
