/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * Contains information about a button.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2IntentMessageCardButton extends com.google.api.client.json.GenericJson {

  /**
   * Optional. The text to send back to the Dialogflow API or a URI to open.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String postback;

  /**
   * Optional. The text to show on the button.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String text;

  /**
   * Optional. The text to send back to the Dialogflow API or a URI to open.
   * @return value or {@code null} for none
   */
  public java.lang.String getPostback() {
    return postback;
  }

  /**
   * Optional. The text to send back to the Dialogflow API or a URI to open.
   * @param postback postback or {@code null} for none
   */
  public GoogleCloudDialogflowV2IntentMessageCardButton setPostback(java.lang.String postback) {
    this.postback = postback;
    return this;
  }

  /**
   * Optional. The text to show on the button.
   * @return value or {@code null} for none
   */
  public java.lang.String getText() {
    return text;
  }

  /**
   * Optional. The text to show on the button.
   * @param text text or {@code null} for none
   */
  public GoogleCloudDialogflowV2IntentMessageCardButton setText(java.lang.String text) {
    this.text = text;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2IntentMessageCardButton set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2IntentMessageCardButton) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2IntentMessageCardButton clone() {
    return (GoogleCloudDialogflowV2IntentMessageCardButton) super.clone();
  }

}
