/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * An item in the list.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2IntentMessageListSelectItem extends com.google.api.client.json.GenericJson {

  /**
   * Optional. The main text describing the item.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String description;

  /**
   * Optional. The image to display.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private GoogleCloudDialogflowV2IntentMessageImage image;

  /**
   * Required. Additional information about this option.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private GoogleCloudDialogflowV2IntentMessageSelectItemInfo info;

  /**
   * Required. The title of the list item.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String title;

  /**
   * Optional. The main text describing the item.
   * @return value or {@code null} for none
   */
  public java.lang.String getDescription() {
    return description;
  }

  /**
   * Optional. The main text describing the item.
   * @param description description or {@code null} for none
   */
  public GoogleCloudDialogflowV2IntentMessageListSelectItem setDescription(java.lang.String description) {
    this.description = description;
    return this;
  }

  /**
   * Optional. The image to display.
   * @return value or {@code null} for none
   */
  public GoogleCloudDialogflowV2IntentMessageImage getImage() {
    return image;
  }

  /**
   * Optional. The image to display.
   * @param image image or {@code null} for none
   */
  public GoogleCloudDialogflowV2IntentMessageListSelectItem setImage(GoogleCloudDialogflowV2IntentMessageImage image) {
    this.image = image;
    return this;
  }

  /**
   * Required. Additional information about this option.
   * @return value or {@code null} for none
   */
  public GoogleCloudDialogflowV2IntentMessageSelectItemInfo getInfo() {
    return info;
  }

  /**
   * Required. Additional information about this option.
   * @param info info or {@code null} for none
   */
  public GoogleCloudDialogflowV2IntentMessageListSelectItem setInfo(GoogleCloudDialogflowV2IntentMessageSelectItemInfo info) {
    this.info = info;
    return this;
  }

  /**
   * Required. The title of the list item.
   * @return value or {@code null} for none
   */
  public java.lang.String getTitle() {
    return title;
  }

  /**
   * Required. The title of the list item.
   * @param title title or {@code null} for none
   */
  public GoogleCloudDialogflowV2IntentMessageListSelectItem setTitle(java.lang.String title) {
    this.title = title;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2IntentMessageListSelectItem set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2IntentMessageListSelectItem) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2IntentMessageListSelectItem clone() {
    return (GoogleCloudDialogflowV2IntentMessageListSelectItem) super.clone();
  }

}
