/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * Additional info about the select item for when it is triggered in a dialog.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2IntentMessageSelectItemInfo extends com.google.api.client.json.GenericJson {

  /**
   * Required. A unique key that will be sent back to the agent if this response is given.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String key;

  /**
   * Optional. A list of synonyms that can also be used to trigger this item in dialog.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> synonyms;

  /**
   * Required. A unique key that will be sent back to the agent if this response is given.
   * @return value or {@code null} for none
   */
  public java.lang.String getKey() {
    return key;
  }

  /**
   * Required. A unique key that will be sent back to the agent if this response is given.
   * @param key key or {@code null} for none
   */
  public GoogleCloudDialogflowV2IntentMessageSelectItemInfo setKey(java.lang.String key) {
    this.key = key;
    return this;
  }

  /**
   * Optional. A list of synonyms that can also be used to trigger this item in dialog.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getSynonyms() {
    return synonyms;
  }

  /**
   * Optional. A list of synonyms that can also be used to trigger this item in dialog.
   * @param synonyms synonyms or {@code null} for none
   */
  public GoogleCloudDialogflowV2IntentMessageSelectItemInfo setSynonyms(java.util.List<java.lang.String> synonyms) {
    this.synonyms = synonyms;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2IntentMessageSelectItemInfo set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2IntentMessageSelectItemInfo) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2IntentMessageSelectItemInfo clone() {
    return (GoogleCloudDialogflowV2IntentMessageSelectItemInfo) super.clone();
  }

}
