/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * Represents the contents of the original request that was passed to the `[Streaming]DetectIntent`
 * call.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2OriginalDetectIntentRequest extends com.google.api.client.json.GenericJson {

  /**
   * Optional. This field is set to the value of the `QueryParameters.payload` field passed in the
   * request. Some integrations that query a Dialogflow agent may provide additional information in
   * the payload.
   *
   * In particular, for the Dialogflow Phone Gateway integration, this field has the form: {
   * "telephony": {    "caller_id": "+18558363987"  } } Note: The caller ID field (`caller_id`) will
   * be redacted for Standard Edition agents and populated with the caller ID in [E.164
   * format](https://en.wikipedia.org/wiki/E.164) for Enterprise Edition agents.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.Map<String, java.lang.Object> payload;

  /**
   * The source of this request, e.g., `google`, `facebook`, `slack`. It is set by Dialogflow-owned
   * servers.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String source;

  /**
   * Optional. The version of the protocol used for this request. This field is AoG-specific.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String version;

  /**
   * Optional. This field is set to the value of the `QueryParameters.payload` field passed in the
   * request. Some integrations that query a Dialogflow agent may provide additional information in
   * the payload.
   *
   * In particular, for the Dialogflow Phone Gateway integration, this field has the form: {
   * "telephony": {    "caller_id": "+18558363987"  } } Note: The caller ID field (`caller_id`) will
   * be redacted for Standard Edition agents and populated with the caller ID in [E.164
   * format](https://en.wikipedia.org/wiki/E.164) for Enterprise Edition agents.
   * @return value or {@code null} for none
   */
  public java.util.Map<String, java.lang.Object> getPayload() {
    return payload;
  }

  /**
   * Optional. This field is set to the value of the `QueryParameters.payload` field passed in the
   * request. Some integrations that query a Dialogflow agent may provide additional information in
   * the payload.
   *
   * In particular, for the Dialogflow Phone Gateway integration, this field has the form: {
   * "telephony": {    "caller_id": "+18558363987"  } } Note: The caller ID field (`caller_id`) will
   * be redacted for Standard Edition agents and populated with the caller ID in [E.164
   * format](https://en.wikipedia.org/wiki/E.164) for Enterprise Edition agents.
   * @param payload payload or {@code null} for none
   */
  public GoogleCloudDialogflowV2OriginalDetectIntentRequest setPayload(java.util.Map<String, java.lang.Object> payload) {
    this.payload = payload;
    return this;
  }

  /**
   * The source of this request, e.g., `google`, `facebook`, `slack`. It is set by Dialogflow-owned
   * servers.
   * @return value or {@code null} for none
   */
  public java.lang.String getSource() {
    return source;
  }

  /**
   * The source of this request, e.g., `google`, `facebook`, `slack`. It is set by Dialogflow-owned
   * servers.
   * @param source source or {@code null} for none
   */
  public GoogleCloudDialogflowV2OriginalDetectIntentRequest setSource(java.lang.String source) {
    this.source = source;
    return this;
  }

  /**
   * Optional. The version of the protocol used for this request. This field is AoG-specific.
   * @return value or {@code null} for none
   */
  public java.lang.String getVersion() {
    return version;
  }

  /**
   * Optional. The version of the protocol used for this request. This field is AoG-specific.
   * @param version version or {@code null} for none
   */
  public GoogleCloudDialogflowV2OriginalDetectIntentRequest setVersion(java.lang.String version) {
    this.version = version;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2OriginalDetectIntentRequest set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2OriginalDetectIntentRequest) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2OriginalDetectIntentRequest clone() {
    return (GoogleCloudDialogflowV2OriginalDetectIntentRequest) super.clone();
  }

}
