/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * Represents the query input. It can contain either:
 *
 * 1.  An audio config which     instructs the speech recognizer how to process the speech audio.
 *
 * 2.  A conversational query in the form of text,.
 *
 * 3.  An event that specifies which intent to trigger.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2QueryInput extends com.google.api.client.json.GenericJson {

  /**
   * Instructs the speech recognizer how to process the speech audio.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private GoogleCloudDialogflowV2InputAudioConfig audioConfig;

  /**
   * The event to be processed.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private GoogleCloudDialogflowV2EventInput event;

  /**
   * The natural language text to be processed.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private GoogleCloudDialogflowV2TextInput text;

  /**
   * Instructs the speech recognizer how to process the speech audio.
   * @return value or {@code null} for none
   */
  public GoogleCloudDialogflowV2InputAudioConfig getAudioConfig() {
    return audioConfig;
  }

  /**
   * Instructs the speech recognizer how to process the speech audio.
   * @param audioConfig audioConfig or {@code null} for none
   */
  public GoogleCloudDialogflowV2QueryInput setAudioConfig(GoogleCloudDialogflowV2InputAudioConfig audioConfig) {
    this.audioConfig = audioConfig;
    return this;
  }

  /**
   * The event to be processed.
   * @return value or {@code null} for none
   */
  public GoogleCloudDialogflowV2EventInput getEvent() {
    return event;
  }

  /**
   * The event to be processed.
   * @param event event or {@code null} for none
   */
  public GoogleCloudDialogflowV2QueryInput setEvent(GoogleCloudDialogflowV2EventInput event) {
    this.event = event;
    return this;
  }

  /**
   * The natural language text to be processed.
   * @return value or {@code null} for none
   */
  public GoogleCloudDialogflowV2TextInput getText() {
    return text;
  }

  /**
   * The natural language text to be processed.
   * @param text text or {@code null} for none
   */
  public GoogleCloudDialogflowV2QueryInput setText(GoogleCloudDialogflowV2TextInput text) {
    this.text = text;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2QueryInput set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2QueryInput) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2QueryInput clone() {
    return (GoogleCloudDialogflowV2QueryInput) super.clone();
  }

}
