/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * The request message for Agents.RestoreAgent.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2RestoreAgentRequest extends com.google.api.client.json.GenericJson {

  /**
   * Zip compressed raw byte content for agent.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String agentContent;

  /**
   * The URI to a Google Cloud Storage file containing the agent to restore. Note: The URI must
   * start with "gs://".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String agentUri;

  /**
   * Zip compressed raw byte content for agent.
   * @see #decodeAgentContent()
   * @return value or {@code null} for none
   */
  public java.lang.String getAgentContent() {
    return agentContent;
  }

  /**
   * Zip compressed raw byte content for agent.
   * @see #getAgentContent()
   * @return Base64 decoded value or {@code null} for none
   *
   * @since 1.14
   */
  public byte[] decodeAgentContent() {
    return com.google.api.client.util.Base64.decodeBase64(agentContent);
  }

  /**
   * Zip compressed raw byte content for agent.
   * @see #encodeAgentContent()
   * @param agentContent agentContent or {@code null} for none
   */
  public GoogleCloudDialogflowV2RestoreAgentRequest setAgentContent(java.lang.String agentContent) {
    this.agentContent = agentContent;
    return this;
  }

  /**
   * Zip compressed raw byte content for agent.
   * @see #setAgentContent()
   *
   * <p>
   * The value is encoded Base64 or {@code null} for none.
   * </p>
   *
   * @since 1.14
   */
  public GoogleCloudDialogflowV2RestoreAgentRequest encodeAgentContent(byte[] agentContent) {
    this.agentContent = com.google.api.client.util.Base64.encodeBase64URLSafeString(agentContent);
    return this;
  }

  /**
   * The URI to a Google Cloud Storage file containing the agent to restore. Note: The URI must
   * start with "gs://".
   * @return value or {@code null} for none
   */
  public java.lang.String getAgentUri() {
    return agentUri;
  }

  /**
   * The URI to a Google Cloud Storage file containing the agent to restore. Note: The URI must
   * start with "gs://".
   * @param agentUri agentUri or {@code null} for none
   */
  public GoogleCloudDialogflowV2RestoreAgentRequest setAgentUri(java.lang.String agentUri) {
    this.agentUri = agentUri;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2RestoreAgentRequest set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2RestoreAgentRequest) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2RestoreAgentRequest clone() {
    return (GoogleCloudDialogflowV2RestoreAgentRequest) super.clone();
  }

}
