/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * The sentiment, such as positive/negative feeling or association, for a unit of analysis, such as
 * the query text.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2Sentiment extends com.google.api.client.json.GenericJson {

  /**
   * A non-negative number in the [0, +inf) range, which represents the absolute magnitude of
   * sentiment, regardless of score (positive or negative).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Float magnitude;

  /**
   * Sentiment score between -1.0 (negative sentiment) and 1.0 (positive sentiment).
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Float score;

  /**
   * A non-negative number in the [0, +inf) range, which represents the absolute magnitude of
   * sentiment, regardless of score (positive or negative).
   * @return value or {@code null} for none
   */
  public java.lang.Float getMagnitude() {
    return magnitude;
  }

  /**
   * A non-negative number in the [0, +inf) range, which represents the absolute magnitude of
   * sentiment, regardless of score (positive or negative).
   * @param magnitude magnitude or {@code null} for none
   */
  public GoogleCloudDialogflowV2Sentiment setMagnitude(java.lang.Float magnitude) {
    this.magnitude = magnitude;
    return this;
  }

  /**
   * Sentiment score between -1.0 (negative sentiment) and 1.0 (positive sentiment).
   * @return value or {@code null} for none
   */
  public java.lang.Float getScore() {
    return score;
  }

  /**
   * Sentiment score between -1.0 (negative sentiment) and 1.0 (positive sentiment).
   * @param score score or {@code null} for none
   */
  public GoogleCloudDialogflowV2Sentiment setScore(java.lang.Float score) {
    this.score = score;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2Sentiment set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2Sentiment) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2Sentiment clone() {
    return (GoogleCloudDialogflowV2Sentiment) super.clone();
  }

}
