/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * Represents a single validation error.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2ValidationError extends com.google.api.client.json.GenericJson {

  /**
   * The names of the entries that the error is associated with. Format:
   *
   * - "projects//agent", if the error is associated with the entire agent. -
   * "projects//agent/intents/", if the error is associated with certain intents. -
   * "projects//agent/intents//trainingPhrases/", if the error is associated with certain intent
   * training phrases. - "projects//agent/intents//parameters/", if the error is associated with
   * certain intent parameters. - "projects//agent/entities/", if the error is associated with
   * certain entities.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<java.lang.String> entries;

  /**
   * The detailed error messsage.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String errorMessage;

  /**
   * The severity of the error.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String severity;

  /**
   * The names of the entries that the error is associated with. Format:
   *
   * - "projects//agent", if the error is associated with the entire agent. -
   * "projects//agent/intents/", if the error is associated with certain intents. -
   * "projects//agent/intents//trainingPhrases/", if the error is associated with certain intent
   * training phrases. - "projects//agent/intents//parameters/", if the error is associated with
   * certain intent parameters. - "projects//agent/entities/", if the error is associated with
   * certain entities.
   * @return value or {@code null} for none
   */
  public java.util.List<java.lang.String> getEntries() {
    return entries;
  }

  /**
   * The names of the entries that the error is associated with. Format:
   *
   * - "projects//agent", if the error is associated with the entire agent. -
   * "projects//agent/intents/", if the error is associated with certain intents. -
   * "projects//agent/intents//trainingPhrases/", if the error is associated with certain intent
   * training phrases. - "projects//agent/intents//parameters/", if the error is associated with
   * certain intent parameters. - "projects//agent/entities/", if the error is associated with
   * certain entities.
   * @param entries entries or {@code null} for none
   */
  public GoogleCloudDialogflowV2ValidationError setEntries(java.util.List<java.lang.String> entries) {
    this.entries = entries;
    return this;
  }

  /**
   * The detailed error messsage.
   * @return value or {@code null} for none
   */
  public java.lang.String getErrorMessage() {
    return errorMessage;
  }

  /**
   * The detailed error messsage.
   * @param errorMessage errorMessage or {@code null} for none
   */
  public GoogleCloudDialogflowV2ValidationError setErrorMessage(java.lang.String errorMessage) {
    this.errorMessage = errorMessage;
    return this;
  }

  /**
   * The severity of the error.
   * @return value or {@code null} for none
   */
  public java.lang.String getSeverity() {
    return severity;
  }

  /**
   * The severity of the error.
   * @param severity severity or {@code null} for none
   */
  public GoogleCloudDialogflowV2ValidationError setSeverity(java.lang.String severity) {
    this.severity = severity;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2ValidationError set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2ValidationError) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2ValidationError clone() {
    return (GoogleCloudDialogflowV2ValidationError) super.clone();
  }

}
