/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * The response message for a webhook call.
 *
 * This response is validated by the Dialogflow server. If validation fails, an error will be
 * returned in the QueryResult.diagnostic_info field. Setting JSON fields to an empty value with the
 * wrong type is a common error. To avoid this error:
 *
 * - Use `""` for empty strings - Use `{}` or `null` for empty objects - Use `[]` or `null` for
 * empty arrays
 *
 * For more information, see the [Protocol Buffers Language Guide](https://developers.google.com
 * /protocol-buffers/docs/proto3#json).
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2WebhookResponse extends com.google.api.client.json.GenericJson {

  /**
   * Optional. Makes the platform immediately invoke another `DetectIntent` call internally with the
   * specified event as input. When this field is set, Dialogflow ignores the `fulfillment_text`,
   * `fulfillment_messages`, and `payload` fields.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private GoogleCloudDialogflowV2EventInput followupEventInput;

  /**
   * Optional. The collection of rich messages to present to the user. This value is passed directly
   * to `QueryResult.fulfillment_messages`.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<GoogleCloudDialogflowV2IntentMessage> fulfillmentMessages;

  /**
   * Optional. The text to be shown on the screen. This value is passed directly to
   * `QueryResult.fulfillment_text`.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String fulfillmentText;

  /**
   * Optional. The collection of output contexts. This value is passed directly to
   * `QueryResult.output_contexts`.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<GoogleCloudDialogflowV2Context> outputContexts;

  /**
   * Optional. This field can be used to pass custom data from your webhook to the API caller.
   * Arbitrary JSON objects are supported. When provided, Dialogflow uses this field to populate
   * `QueryResult.webhook_payload` sent to the API caller. This field is also used by the [Google
   * Assistant integration](https://cloud.google.com/dialogflow/docs/integrations/aog) for rich
   * response messages. See the format definition at [Google Assistant Dialogflow webhook
   * format](https://developers.google.com/assistant/actions/build/json/dialogflow-webhook-json)
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.Map<String, java.lang.Object> payload;

  /**
   * Optional. Additional session entity types to replace or extend developer entity types with. The
   * entity synonyms apply to all languages and persist for the session of this query. Setting the
   * session entity types inside webhook overwrites the session entity types that have been set
   * through `DetectIntentRequest.query_params.session_entity_types`.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<GoogleCloudDialogflowV2SessionEntityType> sessionEntityTypes;

  static {
    // hack to force ProGuard to consider GoogleCloudDialogflowV2SessionEntityType used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(GoogleCloudDialogflowV2SessionEntityType.class);
  }

  /**
   * Optional. This value is passed directly to `QueryResult.webhook_source`.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String source;

  /**
   * Optional. Makes the platform immediately invoke another `DetectIntent` call internally with the
   * specified event as input. When this field is set, Dialogflow ignores the `fulfillment_text`,
   * `fulfillment_messages`, and `payload` fields.
   * @return value or {@code null} for none
   */
  public GoogleCloudDialogflowV2EventInput getFollowupEventInput() {
    return followupEventInput;
  }

  /**
   * Optional. Makes the platform immediately invoke another `DetectIntent` call internally with the
   * specified event as input. When this field is set, Dialogflow ignores the `fulfillment_text`,
   * `fulfillment_messages`, and `payload` fields.
   * @param followupEventInput followupEventInput or {@code null} for none
   */
  public GoogleCloudDialogflowV2WebhookResponse setFollowupEventInput(GoogleCloudDialogflowV2EventInput followupEventInput) {
    this.followupEventInput = followupEventInput;
    return this;
  }

  /**
   * Optional. The collection of rich messages to present to the user. This value is passed directly
   * to `QueryResult.fulfillment_messages`.
   * @return value or {@code null} for none
   */
  public java.util.List<GoogleCloudDialogflowV2IntentMessage> getFulfillmentMessages() {
    return fulfillmentMessages;
  }

  /**
   * Optional. The collection of rich messages to present to the user. This value is passed directly
   * to `QueryResult.fulfillment_messages`.
   * @param fulfillmentMessages fulfillmentMessages or {@code null} for none
   */
  public GoogleCloudDialogflowV2WebhookResponse setFulfillmentMessages(java.util.List<GoogleCloudDialogflowV2IntentMessage> fulfillmentMessages) {
    this.fulfillmentMessages = fulfillmentMessages;
    return this;
  }

  /**
   * Optional. The text to be shown on the screen. This value is passed directly to
   * `QueryResult.fulfillment_text`.
   * @return value or {@code null} for none
   */
  public java.lang.String getFulfillmentText() {
    return fulfillmentText;
  }

  /**
   * Optional. The text to be shown on the screen. This value is passed directly to
   * `QueryResult.fulfillment_text`.
   * @param fulfillmentText fulfillmentText or {@code null} for none
   */
  public GoogleCloudDialogflowV2WebhookResponse setFulfillmentText(java.lang.String fulfillmentText) {
    this.fulfillmentText = fulfillmentText;
    return this;
  }

  /**
   * Optional. The collection of output contexts. This value is passed directly to
   * `QueryResult.output_contexts`.
   * @return value or {@code null} for none
   */
  public java.util.List<GoogleCloudDialogflowV2Context> getOutputContexts() {
    return outputContexts;
  }

  /**
   * Optional. The collection of output contexts. This value is passed directly to
   * `QueryResult.output_contexts`.
   * @param outputContexts outputContexts or {@code null} for none
   */
  public GoogleCloudDialogflowV2WebhookResponse setOutputContexts(java.util.List<GoogleCloudDialogflowV2Context> outputContexts) {
    this.outputContexts = outputContexts;
    return this;
  }

  /**
   * Optional. This field can be used to pass custom data from your webhook to the API caller.
   * Arbitrary JSON objects are supported. When provided, Dialogflow uses this field to populate
   * `QueryResult.webhook_payload` sent to the API caller. This field is also used by the [Google
   * Assistant integration](https://cloud.google.com/dialogflow/docs/integrations/aog) for rich
   * response messages. See the format definition at [Google Assistant Dialogflow webhook
   * format](https://developers.google.com/assistant/actions/build/json/dialogflow-webhook-json)
   * @return value or {@code null} for none
   */
  public java.util.Map<String, java.lang.Object> getPayload() {
    return payload;
  }

  /**
   * Optional. This field can be used to pass custom data from your webhook to the API caller.
   * Arbitrary JSON objects are supported. When provided, Dialogflow uses this field to populate
   * `QueryResult.webhook_payload` sent to the API caller. This field is also used by the [Google
   * Assistant integration](https://cloud.google.com/dialogflow/docs/integrations/aog) for rich
   * response messages. See the format definition at [Google Assistant Dialogflow webhook
   * format](https://developers.google.com/assistant/actions/build/json/dialogflow-webhook-json)
   * @param payload payload or {@code null} for none
   */
  public GoogleCloudDialogflowV2WebhookResponse setPayload(java.util.Map<String, java.lang.Object> payload) {
    this.payload = payload;
    return this;
  }

  /**
   * Optional. Additional session entity types to replace or extend developer entity types with. The
   * entity synonyms apply to all languages and persist for the session of this query. Setting the
   * session entity types inside webhook overwrites the session entity types that have been set
   * through `DetectIntentRequest.query_params.session_entity_types`.
   * @return value or {@code null} for none
   */
  public java.util.List<GoogleCloudDialogflowV2SessionEntityType> getSessionEntityTypes() {
    return sessionEntityTypes;
  }

  /**
   * Optional. Additional session entity types to replace or extend developer entity types with. The
   * entity synonyms apply to all languages and persist for the session of this query. Setting the
   * session entity types inside webhook overwrites the session entity types that have been set
   * through `DetectIntentRequest.query_params.session_entity_types`.
   * @param sessionEntityTypes sessionEntityTypes or {@code null} for none
   */
  public GoogleCloudDialogflowV2WebhookResponse setSessionEntityTypes(java.util.List<GoogleCloudDialogflowV2SessionEntityType> sessionEntityTypes) {
    this.sessionEntityTypes = sessionEntityTypes;
    return this;
  }

  /**
   * Optional. This value is passed directly to `QueryResult.webhook_source`.
   * @return value or {@code null} for none
   */
  public java.lang.String getSource() {
    return source;
  }

  /**
   * Optional. This value is passed directly to `QueryResult.webhook_source`.
   * @param source source or {@code null} for none
   */
  public GoogleCloudDialogflowV2WebhookResponse setSource(java.lang.String source) {
    this.source = source;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2WebhookResponse set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2WebhookResponse) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2WebhookResponse clone() {
    return (GoogleCloudDialogflowV2WebhookResponse) super.clone();
  }

}
