/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * Represents an annotated conversation dataset. ConversationDataset can have multiple
 * AnnotatedConversationDataset, each of them represents one result from one annotation task.
 * AnnotatedConversationDataset can only be generated from annotation task, which will be triggered
 * by LabelConversation.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2beta1AnnotatedConversationDataset extends com.google.api.client.json.GenericJson {

  /**
   * Output only. Number of examples that have annotations in the annotated conversation dataset.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long completedExampleCount;

  /**
   * Output only. Creation time of this annotated conversation dataset.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private String createTime;

  /**
   * Optional. The description of the annotated conversation dataset. Maximum of 10000 bytes.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String description;

  /**
   * Required. The display name of the annotated conversation dataset. It's specified when user
   * starts an annotation task. Maximum of 64 bytes.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String displayName;

  /**
   * Output only. Number of examples in the annotated conversation dataset.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key @com.google.api.client.json.JsonString
  private java.lang.Long exampleCount;

  /**
   * Output only. AnnotatedConversationDataset resource name. Format:
   * `projects//conversationDatasets//annotatedConversationDatasets/`
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * Output only. Question type name that identifies a labeling task. A question is a single task
   * that a worker answers. A question type is set of related questions. Each question belongs to a
   * particular question type. It can be used in CrowdCompute UI to filter and manage labeling
   * tasks.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String questionTypeName;

  /**
   * Output only. Number of examples that have annotations in the annotated conversation dataset.
   * @return value or {@code null} for none
   */
  public java.lang.Long getCompletedExampleCount() {
    return completedExampleCount;
  }

  /**
   * Output only. Number of examples that have annotations in the annotated conversation dataset.
   * @param completedExampleCount completedExampleCount or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1AnnotatedConversationDataset setCompletedExampleCount(java.lang.Long completedExampleCount) {
    this.completedExampleCount = completedExampleCount;
    return this;
  }

  /**
   * Output only. Creation time of this annotated conversation dataset.
   * @return value or {@code null} for none
   */
  public String getCreateTime() {
    return createTime;
  }

  /**
   * Output only. Creation time of this annotated conversation dataset.
   * @param createTime createTime or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1AnnotatedConversationDataset setCreateTime(String createTime) {
    this.createTime = createTime;
    return this;
  }

  /**
   * Optional. The description of the annotated conversation dataset. Maximum of 10000 bytes.
   * @return value or {@code null} for none
   */
  public java.lang.String getDescription() {
    return description;
  }

  /**
   * Optional. The description of the annotated conversation dataset. Maximum of 10000 bytes.
   * @param description description or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1AnnotatedConversationDataset setDescription(java.lang.String description) {
    this.description = description;
    return this;
  }

  /**
   * Required. The display name of the annotated conversation dataset. It's specified when user
   * starts an annotation task. Maximum of 64 bytes.
   * @return value or {@code null} for none
   */
  public java.lang.String getDisplayName() {
    return displayName;
  }

  /**
   * Required. The display name of the annotated conversation dataset. It's specified when user
   * starts an annotation task. Maximum of 64 bytes.
   * @param displayName displayName or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1AnnotatedConversationDataset setDisplayName(java.lang.String displayName) {
    this.displayName = displayName;
    return this;
  }

  /**
   * Output only. Number of examples in the annotated conversation dataset.
   * @return value or {@code null} for none
   */
  public java.lang.Long getExampleCount() {
    return exampleCount;
  }

  /**
   * Output only. Number of examples in the annotated conversation dataset.
   * @param exampleCount exampleCount or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1AnnotatedConversationDataset setExampleCount(java.lang.Long exampleCount) {
    this.exampleCount = exampleCount;
    return this;
  }

  /**
   * Output only. AnnotatedConversationDataset resource name. Format:
   * `projects//conversationDatasets//annotatedConversationDatasets/`
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * Output only. AnnotatedConversationDataset resource name. Format:
   * `projects//conversationDatasets//annotatedConversationDatasets/`
   * @param name name or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1AnnotatedConversationDataset setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  /**
   * Output only. Question type name that identifies a labeling task. A question is a single task
   * that a worker answers. A question type is set of related questions. Each question belongs to a
   * particular question type. It can be used in CrowdCompute UI to filter and manage labeling
   * tasks.
   * @return value or {@code null} for none
   */
  public java.lang.String getQuestionTypeName() {
    return questionTypeName;
  }

  /**
   * Output only. Question type name that identifies a labeling task. A question is a single task
   * that a worker answers. A question type is set of related questions. Each question belongs to a
   * particular question type. It can be used in CrowdCompute UI to filter and manage labeling
   * tasks.
   * @param questionTypeName questionTypeName or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1AnnotatedConversationDataset setQuestionTypeName(java.lang.String questionTypeName) {
    this.questionTypeName = questionTypeName;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2beta1AnnotatedConversationDataset set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2beta1AnnotatedConversationDataset) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2beta1AnnotatedConversationDataset clone() {
    return (GoogleCloudDialogflowV2beta1AnnotatedConversationDataset) super.clone();
  }

}
