/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * The card for presenting a list of options to select from.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2beta1IntentMessageListSelect extends com.google.api.client.json.GenericJson {

  /**
   * Required. List items.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<GoogleCloudDialogflowV2beta1IntentMessageListSelectItem> items;

  /**
   * Optional. Subtitle of the list.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String subtitle;

  /**
   * Optional. The overall title of the list.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String title;

  /**
   * Required. List items.
   * @return value or {@code null} for none
   */
  public java.util.List<GoogleCloudDialogflowV2beta1IntentMessageListSelectItem> getItems() {
    return items;
  }

  /**
   * Required. List items.
   * @param items items or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageListSelect setItems(java.util.List<GoogleCloudDialogflowV2beta1IntentMessageListSelectItem> items) {
    this.items = items;
    return this;
  }

  /**
   * Optional. Subtitle of the list.
   * @return value or {@code null} for none
   */
  public java.lang.String getSubtitle() {
    return subtitle;
  }

  /**
   * Optional. Subtitle of the list.
   * @param subtitle subtitle or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageListSelect setSubtitle(java.lang.String subtitle) {
    this.subtitle = subtitle;
    return this;
  }

  /**
   * Optional. The overall title of the list.
   * @return value or {@code null} for none
   */
  public java.lang.String getTitle() {
    return title;
  }

  /**
   * Optional. The overall title of the list.
   * @param title title or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageListSelect setTitle(java.lang.String title) {
    this.title = title;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2beta1IntentMessageListSelect set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2beta1IntentMessageListSelect) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2beta1IntentMessageListSelect clone() {
    return (GoogleCloudDialogflowV2beta1IntentMessageListSelect) super.clone();
  }

}
