/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * Response media object for media content card.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2beta1IntentMessageMediaContentResponseMediaObject extends com.google.api.client.json.GenericJson {

  /**
   * Required. Url where the media is stored.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String contentUrl;

  /**
   * Optional. Description of media card.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String description;

  /**
   * Optional. Icon to display above media content.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private GoogleCloudDialogflowV2beta1IntentMessageImage icon;

  /**
   * Optional. Image to display above media content.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private GoogleCloudDialogflowV2beta1IntentMessageImage largeImage;

  /**
   * Required. Name of media card.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String name;

  /**
   * Required. Url where the media is stored.
   * @return value or {@code null} for none
   */
  public java.lang.String getContentUrl() {
    return contentUrl;
  }

  /**
   * Required. Url where the media is stored.
   * @param contentUrl contentUrl or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageMediaContentResponseMediaObject setContentUrl(java.lang.String contentUrl) {
    this.contentUrl = contentUrl;
    return this;
  }

  /**
   * Optional. Description of media card.
   * @return value or {@code null} for none
   */
  public java.lang.String getDescription() {
    return description;
  }

  /**
   * Optional. Description of media card.
   * @param description description or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageMediaContentResponseMediaObject setDescription(java.lang.String description) {
    this.description = description;
    return this;
  }

  /**
   * Optional. Icon to display above media content.
   * @return value or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageImage getIcon() {
    return icon;
  }

  /**
   * Optional. Icon to display above media content.
   * @param icon icon or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageMediaContentResponseMediaObject setIcon(GoogleCloudDialogflowV2beta1IntentMessageImage icon) {
    this.icon = icon;
    return this;
  }

  /**
   * Optional. Image to display above media content.
   * @return value or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageImage getLargeImage() {
    return largeImage;
  }

  /**
   * Optional. Image to display above media content.
   * @param largeImage largeImage or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageMediaContentResponseMediaObject setLargeImage(GoogleCloudDialogflowV2beta1IntentMessageImage largeImage) {
    this.largeImage = largeImage;
    return this;
  }

  /**
   * Required. Name of media card.
   * @return value or {@code null} for none
   */
  public java.lang.String getName() {
    return name;
  }

  /**
   * Required. Name of media card.
   * @param name name or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageMediaContentResponseMediaObject setName(java.lang.String name) {
    this.name = name;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2beta1IntentMessageMediaContentResponseMediaObject set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2beta1IntentMessageMediaContentResponseMediaObject) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2beta1IntentMessageMediaContentResponseMediaObject clone() {
    return (GoogleCloudDialogflowV2beta1IntentMessageMediaContentResponseMediaObject) super.clone();
  }

}
