/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * Rich Business Messaging (RBM) Card content
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2beta1IntentMessageRbmCardContent extends com.google.api.client.json.GenericJson {

  /**
   * Optional. Description of the card (at most 2000 bytes).
   *
   * At least one of the title, description or media must be set.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String description;

  /**
   * Optional. However at least one of the title, description or media must be set. Media (image,
   * GIF or a video) to include in the card.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private GoogleCloudDialogflowV2beta1IntentMessageRbmCardContentRbmMedia media;

  /**
   * Optional. List of suggestions to include in the card.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<GoogleCloudDialogflowV2beta1IntentMessageRbmSuggestion> suggestions;

  static {
    // hack to force ProGuard to consider GoogleCloudDialogflowV2beta1IntentMessageRbmSuggestion used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(GoogleCloudDialogflowV2beta1IntentMessageRbmSuggestion.class);
  }

  /**
   * Optional. Title of the card (at most 200 bytes).
   *
   * At least one of the title, description or media must be set.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String title;

  /**
   * Optional. Description of the card (at most 2000 bytes).
   *
   * At least one of the title, description or media must be set.
   * @return value or {@code null} for none
   */
  public java.lang.String getDescription() {
    return description;
  }

  /**
   * Optional. Description of the card (at most 2000 bytes).
   *
   * At least one of the title, description or media must be set.
   * @param description description or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageRbmCardContent setDescription(java.lang.String description) {
    this.description = description;
    return this;
  }

  /**
   * Optional. However at least one of the title, description or media must be set. Media (image,
   * GIF or a video) to include in the card.
   * @return value or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageRbmCardContentRbmMedia getMedia() {
    return media;
  }

  /**
   * Optional. However at least one of the title, description or media must be set. Media (image,
   * GIF or a video) to include in the card.
   * @param media media or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageRbmCardContent setMedia(GoogleCloudDialogflowV2beta1IntentMessageRbmCardContentRbmMedia media) {
    this.media = media;
    return this;
  }

  /**
   * Optional. List of suggestions to include in the card.
   * @return value or {@code null} for none
   */
  public java.util.List<GoogleCloudDialogflowV2beta1IntentMessageRbmSuggestion> getSuggestions() {
    return suggestions;
  }

  /**
   * Optional. List of suggestions to include in the card.
   * @param suggestions suggestions or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageRbmCardContent setSuggestions(java.util.List<GoogleCloudDialogflowV2beta1IntentMessageRbmSuggestion> suggestions) {
    this.suggestions = suggestions;
    return this;
  }

  /**
   * Optional. Title of the card (at most 200 bytes).
   *
   * At least one of the title, description or media must be set.
   * @return value or {@code null} for none
   */
  public java.lang.String getTitle() {
    return title;
  }

  /**
   * Optional. Title of the card (at most 200 bytes).
   *
   * At least one of the title, description or media must be set.
   * @param title title or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageRbmCardContent setTitle(java.lang.String title) {
    this.title = title;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2beta1IntentMessageRbmCardContent set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2beta1IntentMessageRbmCardContent) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2beta1IntentMessageRbmCardContent clone() {
    return (GoogleCloudDialogflowV2beta1IntentMessageRbmCardContent) super.clone();
  }

}
