/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * Rich Business Messaging (RBM) suggestion. Suggestions allow user to easily select/click a
 * predefined response or perform an action (like opening a web uri).
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2beta1IntentMessageRbmSuggestion extends com.google.api.client.json.GenericJson {

  /**
   * Predefined client side actions that user can choose
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private GoogleCloudDialogflowV2beta1IntentMessageRbmSuggestedAction action;

  /**
   * Predefined replies for user to select instead of typing
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private GoogleCloudDialogflowV2beta1IntentMessageRbmSuggestedReply reply;

  /**
   * Predefined client side actions that user can choose
   * @return value or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageRbmSuggestedAction getAction() {
    return action;
  }

  /**
   * Predefined client side actions that user can choose
   * @param action action or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageRbmSuggestion setAction(GoogleCloudDialogflowV2beta1IntentMessageRbmSuggestedAction action) {
    this.action = action;
    return this;
  }

  /**
   * Predefined replies for user to select instead of typing
   * @return value or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageRbmSuggestedReply getReply() {
    return reply;
  }

  /**
   * Predefined replies for user to select instead of typing
   * @param reply reply or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageRbmSuggestion setReply(GoogleCloudDialogflowV2beta1IntentMessageRbmSuggestedReply reply) {
    this.reply = reply;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2beta1IntentMessageRbmSuggestion set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2beta1IntentMessageRbmSuggestion) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2beta1IntentMessageRbmSuggestion clone() {
    return (GoogleCloudDialogflowV2beta1IntentMessageRbmSuggestion) super.clone();
  }

}
