/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * Table card for Actions on Google.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2beta1IntentMessageTableCard extends com.google.api.client.json.GenericJson {

  /**
   * Optional. List of buttons for the card.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<GoogleCloudDialogflowV2beta1IntentMessageBasicCardButton> buttons;

  /**
   * Optional. Display properties for the columns in this table.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<GoogleCloudDialogflowV2beta1IntentMessageColumnProperties> columnProperties;

  /**
   * Optional. Image which should be displayed on the card.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private GoogleCloudDialogflowV2beta1IntentMessageImage image;

  /**
   * Optional. Rows in this table of data.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<GoogleCloudDialogflowV2beta1IntentMessageTableCardRow> rows;

  static {
    // hack to force ProGuard to consider GoogleCloudDialogflowV2beta1IntentMessageTableCardRow used, since otherwise it would be stripped out
    // see https://github.com/google/google-api-java-client/issues/543
    com.google.api.client.util.Data.nullOf(GoogleCloudDialogflowV2beta1IntentMessageTableCardRow.class);
  }

  /**
   * Optional. Subtitle to the title.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String subtitle;

  /**
   * Required. Title of the card.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String title;

  /**
   * Optional. List of buttons for the card.
   * @return value or {@code null} for none
   */
  public java.util.List<GoogleCloudDialogflowV2beta1IntentMessageBasicCardButton> getButtons() {
    return buttons;
  }

  /**
   * Optional. List of buttons for the card.
   * @param buttons buttons or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageTableCard setButtons(java.util.List<GoogleCloudDialogflowV2beta1IntentMessageBasicCardButton> buttons) {
    this.buttons = buttons;
    return this;
  }

  /**
   * Optional. Display properties for the columns in this table.
   * @return value or {@code null} for none
   */
  public java.util.List<GoogleCloudDialogflowV2beta1IntentMessageColumnProperties> getColumnProperties() {
    return columnProperties;
  }

  /**
   * Optional. Display properties for the columns in this table.
   * @param columnProperties columnProperties or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageTableCard setColumnProperties(java.util.List<GoogleCloudDialogflowV2beta1IntentMessageColumnProperties> columnProperties) {
    this.columnProperties = columnProperties;
    return this;
  }

  /**
   * Optional. Image which should be displayed on the card.
   * @return value or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageImage getImage() {
    return image;
  }

  /**
   * Optional. Image which should be displayed on the card.
   * @param image image or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageTableCard setImage(GoogleCloudDialogflowV2beta1IntentMessageImage image) {
    this.image = image;
    return this;
  }

  /**
   * Optional. Rows in this table of data.
   * @return value or {@code null} for none
   */
  public java.util.List<GoogleCloudDialogflowV2beta1IntentMessageTableCardRow> getRows() {
    return rows;
  }

  /**
   * Optional. Rows in this table of data.
   * @param rows rows or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageTableCard setRows(java.util.List<GoogleCloudDialogflowV2beta1IntentMessageTableCardRow> rows) {
    this.rows = rows;
    return this;
  }

  /**
   * Optional. Subtitle to the title.
   * @return value or {@code null} for none
   */
  public java.lang.String getSubtitle() {
    return subtitle;
  }

  /**
   * Optional. Subtitle to the title.
   * @param subtitle subtitle or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageTableCard setSubtitle(java.lang.String subtitle) {
    this.subtitle = subtitle;
    return this;
  }

  /**
   * Required. Title of the card.
   * @return value or {@code null} for none
   */
  public java.lang.String getTitle() {
    return title;
  }

  /**
   * Required. Title of the card.
   * @param title title or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageTableCard setTitle(java.lang.String title) {
    this.title = title;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2beta1IntentMessageTableCard set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2beta1IntentMessageTableCard) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2beta1IntentMessageTableCard clone() {
    return (GoogleCloudDialogflowV2beta1IntentMessageTableCard) super.clone();
  }

}
