/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://github.com/google/apis-client-generator/
 * (build: 2018-10-08 17:45:39 UTC)
 * on 2020-04-27 at 14:49:19 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.dialogflow.v2.model;

/**
 * Plays audio from a file in Telephony Gateway.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Dialogflow API. For a detailed explanation see:
 * <a href="https://developers.google.com/api-client-library/java/google-http-java-client/json">https://developers.google.com/api-client-library/java/google-http-java-client/json</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class GoogleCloudDialogflowV2beta1IntentMessageTelephonyPlayAudio extends com.google.api.client.json.GenericJson {

  /**
   * Required. URI to a Google Cloud Storage object containing the audio to play, e.g.,
   * "gs://bucket/object". The object must contain a single channel (mono) of linear PCM audio (2
   * bytes / sample) at 8kHz.
   *
   * This object must be readable by the `service-@gcp-sa-dialogflow.iam.gserviceaccount.com`
   * service account where  is the number of the Telephony Gateway project (usually the same as the
   * Dialogflow agent project). If the Google Cloud Storage bucket is in the Telephony Gateway
   * project, this permission is added by default when enabling the Dialogflow V2 API.
   *
   * For audio from other sources, consider using the `TelephonySynthesizeSpeech` message with SSML.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String audioUri;

  /**
   * Required. URI to a Google Cloud Storage object containing the audio to play, e.g.,
   * "gs://bucket/object". The object must contain a single channel (mono) of linear PCM audio (2
   * bytes / sample) at 8kHz.
   *
   * This object must be readable by the `service-@gcp-sa-dialogflow.iam.gserviceaccount.com`
   * service account where  is the number of the Telephony Gateway project (usually the same as the
   * Dialogflow agent project). If the Google Cloud Storage bucket is in the Telephony Gateway
   * project, this permission is added by default when enabling the Dialogflow V2 API.
   *
   * For audio from other sources, consider using the `TelephonySynthesizeSpeech` message with SSML.
   * @return value or {@code null} for none
   */
  public java.lang.String getAudioUri() {
    return audioUri;
  }

  /**
   * Required. URI to a Google Cloud Storage object containing the audio to play, e.g.,
   * "gs://bucket/object". The object must contain a single channel (mono) of linear PCM audio (2
   * bytes / sample) at 8kHz.
   *
   * This object must be readable by the `service-@gcp-sa-dialogflow.iam.gserviceaccount.com`
   * service account where  is the number of the Telephony Gateway project (usually the same as the
   * Dialogflow agent project). If the Google Cloud Storage bucket is in the Telephony Gateway
   * project, this permission is added by default when enabling the Dialogflow V2 API.
   *
   * For audio from other sources, consider using the `TelephonySynthesizeSpeech` message with SSML.
   * @param audioUri audioUri or {@code null} for none
   */
  public GoogleCloudDialogflowV2beta1IntentMessageTelephonyPlayAudio setAudioUri(java.lang.String audioUri) {
    this.audioUri = audioUri;
    return this;
  }

  @Override
  public GoogleCloudDialogflowV2beta1IntentMessageTelephonyPlayAudio set(String fieldName, Object value) {
    return (GoogleCloudDialogflowV2beta1IntentMessageTelephonyPlayAudio) super.set(fieldName, value);
  }

  @Override
  public GoogleCloudDialogflowV2beta1IntentMessageTelephonyPlayAudio clone() {
    return (GoogleCloudDialogflowV2beta1IntentMessageTelephonyPlayAudio) super.clone();
  }

}
